(function($){
	"use strict";
	var app = {
		el: '',
		msgContainer: false,
		validMails: [],

		submit: function(){
			var self = this;
			$(self.el).trigger('submit');
		},

		request: function(mail){
			if(!$('body').hasClass('bpmvp-loading')){
				var self = this;

				$('body').addClass('bpmvp-loading');

				var inputs = $(self.el).find('.bpmvp-mail');
				_.each($(inputs),function(el,key){
					if($(el).val()==mail){
						$(el).addClass('bpmvp-loading-mail');
					}
				});

				$.ajax({
					url: bpmvp.AJAX_URL,
					type: 'POST',
					cache: false,
					crossDomain: true,
					data: {
						'action'     : 'bpmvp-verify-email',
						'bpmvp-nonce' : bpmvp.nonce,
						'email'       : mail
					},
					dataType: 'json',
					success: function (data) {
						$('body').removeClass('bpmvp-loading');
						var inputs = $(self.el).find('.bpmvp-mail');
						_.each($(inputs),function(el,key){
							if($(el).val()==mail){
								$(el).removeClass('bpmvp-loading-mail');
							}
						});

						if( data.is_valid ){
							self.validMails.push( mail );
							self.submit();
						} else {
							self.showError(mail, data.status);
						}
					},
					error: function(){
						$('body').removeClass('bpmvp-loading');
					}
				});
			}
		},
		validateForm: function( form ){
			var self = this,
				inputs = $(form).find('.bpmvp-mail');

			self.el = form;

			if( $(self.el).find('.wpcf7-response-output').length ){
				self.msgContainer = $(self.el).find('.wpcf7-response-output');
			} else {
				self.msgContainer = false;
			}

			var mails = [],
				inputs = $(form).find('.bpmvp-mail');

			_.each( inputs, function(el, key){
				mails.push( $(inputs[key]).val() );
			});

			if( _.isEmpty( _.difference( mails, app.validMails ) ) ){
				self.submit();
			} else {
				var mail = _.difference( mails, app.validMails );
				self.request( mail[0] );
			}


		},
		showError: function(mail, status){
			var self = this;
			if(self.msgContainer){
				var template = _.template( bpmvp.tpl );
				$(self.msgContainer).html( template( {mail:mail, status: bpmvp[ status ]} ) ).show();
			} else {
				var inputs = $(self.el).find('.bpmvp-mail');
				_.each($(inputs),function(el,key){
					if($(el).val()==mail){
						var template = _.template( bpmvp.tpl );
						$(el).after( template( {mail:mail, status: bpmvp[ status ]} ) );
					}
				});
			}
		}
	};

	$(document).ready(function(){
		if($('form').length){
			_.each( $('form'), function( form, key ){
				if($(form).find('.bpmvp-mail').length){
					$(form).on('submit', function(){
						var mails = [],
							inputs = $(form).find('.bpmvp-mail');

						$(form).find('.bpmvp-error').remove();

						_.each( inputs, function(el, key){
							mails.push( $(inputs[key]).val() );
						});

						if( _.isEmpty( _.difference( mails, app.validMails ) ) ){
							$(form).removeClass( bpmvp.form_class );
							return true;
						} else {
							app.validateForm( $(form) );
						}

						return false;
					});
				}
			});
		}
	});
}(jQuery));